
from bpy import *
from .store import *

# I DON'T KNOW WHICH MODULES I NEED... HELP!!!!!!!!


#####################################################################
# Contains determination of grains for collisions (through potentials)
#####################################################################

#MATRIX OF COSTRAINTS (in Angstrom)
potMat = [
		[5.4, 4.8, 4.4, 4.8, 4.6],
		[4.8, 4.4, 4.4, 6.5, 5.8],
		[4.4, 4.4, 4.2, 4.0, 5.1],
		[4.8, 6.5, 4.0, 5.5, 3.2],
		[4.6, 5.8, 5.1, 3.2, 5.5],
		]

# ca=1	lip=2	hyd=3	pos=4	neg=5
# then if you want the colliding radius for a pair of grains (pos,neg)
# you should take the entry potMat[4,5] or potMat[5,4] (they are the same)

#		ca		lip		hyd		pos		neg



#ca		5.4		4.8		4.4		4.8		4.6



#lip	4.8		4.4		4.4		6.5		5.8



#hyd	4.4		4.4		4.2		4.0		5.1



#pos	4.8		6.5		4.0		5.5		3.2



#neg	4.6		5.8		5.1		3.2		5.5



#DEFINITION OF THE SET OF ALL GRAINS. COULD I USE THE FACT THAT THEY ARE ALL GRAINS?
#def (grain = None, verbose = False):

def dist(x,y):
    return numpy.sqrt(numpy.sum((x-y)**2))


# !!!!!!!!!!!!!!!!!!!!!!! THIS PART SHOULD TUN ONLY AT KEY FRAMES   !!!!!!!!!!!!!!!!!!!!



# store.modelContrainer is where all the data for the imported PDB is stored.
# activetag is the name of the selected/active protein model (because we could have multiple models loaded), we only want to operate on one.
selectedModel = store.modelContainer[activeTag]
# this "for .. in..." line loops through each grain in the scene
for grain.selected, grainInfo in selectedModel.items():	# "grain" should be the blender empty name of the grain How can it be done????? HELP!  Do I add any in their def in aminoCycle.py???????
	if grainInfo.get("grty")=="caa":
		loc = grain.loc
		seq = grain.seq # sequential number for the grain in the creation
	for empty, grainInfo in selectedModel.items():
		if grainInfo.get("num")>seq+5: #to avoid considering the second grain too near (in the sequence) to the first
			if numpy.abs(loc[0],empty.loc[0])<7:
				if numpy.abs(loc[1],empty.loc[1])<7:
					if numpy.abs(loc[2],empty.loc[2])<7:
						d = dist(loc,empty.loc)
						if grainInfo.get(grty)=="caa":
							if d < potMat[1,1]:
								print([grain,empty,potMat[1,1]-d]) # this shoul be in the COLLISIONS list
						if grainInfo.get(grty)=="lip":
							if d < potMat[1,2]:
								print([grain,empty,potMat[1,2]-d]) # this shoul be in the COLLISIONS list
						if grainInfo.get(grty)=="hyd":
							if d < potMat[1,3]:
								print([grain,empty,potMat[1,3]-d]) # this shoul be in the COLLISIONS list
						if grainInfo.get(grty)=="pos":
							if d < potMat[1,4]:
								print([grain,empty,potMat[1,4]-d]) # this shoul be in the COLLISIONS list
						if grainInfo.get(grty)=="neg":
							if d < potMat[1,5]:
								print([grain,empty,potMat[1,5]-d]) # this shoul be in the COLLISIONS list
	if grainInfo.get("grty")=="lip":
		loc = grain.loc
		seq = grain.seq # sequential number for the grain in the creation
	for empty, grainInfo in selectedModel.items():
		if grainInfo.get("num")>seq+5: #to avoid considering the second grain too near (in the sequence) to the first
			if numpy.abs(loc[0],empty.loc[0])<7:
				if numpy.abs(loc[1],empty.loc[1])<7:
					if numpy.abs(loc[2],empty.loc[2])<7:
						d = dist(loc,empty.loc)
						if grainInfo.get(grty)=="caa":
							if d < potMat[2,1]:
								print([grain,empty,potMat[2,1]-d]) # this should be in the COLLISIONS list
						if grainInfo.get(grty)=="lip":
							if d < potMat[2,2]:
								print([grain,empty,potMat[2,2]-d]) # this should be in the COLLISIONS list
						if grainInfo.get(grty)=="hyd":
							if d < potMat[2,3]:
								print([grain,empty,potMat[2,3]-d]) # this should be in the COLLISIONS list
						if grainInfo.get(grty)=="pos":
							if d < potMat[2,4]:
								print([grain,empty,potMat[2,4]-d]) # this should be in the COLLISIONS list
						if grainInfo.get(grty)=="neg":
							if d < potMat[2,5]:
								print([grain,empty,potMat[2,5]-d]) # this should be in the COLLISIONS list
	if grainInfo.get("grty")=="hyd":
		loc = grain.loc
		seq = grain.seq # sequential number for the grain in the creation
	for empty, grainInfo in selectedModel.items():
		if grainInfo.get("num")>seq+5: #to avoid considering the second grain too near (in the sequence) to the first
			if numpy.abs(loc[0],empty.loc[0])<7:
				if numpy.abs(loc[1],empty.loc[1])<7:
					if numpy.abs(loc[2],empty.loc[2])<7:
						d = dist(loc,empty.loc)
						if grainInfo.get(grty)=="caa":
							if d < potMat[3,1]:
								print([grain,empty,potMat[3,1]-d]) # this should be in the COLLISIONS list
						if grainInfo.get(grty)=="lip":
							if d < potMat[3,2]:
								print([grain,empty,potMat[3,2]-d]) # this should be in the COLLISIONS list
						if grainInfo.get(grty)=="hyd":
							if d < potMat[3,3]:
								print([grain,empty,potMat[3,3]-d]) # this should be in the COLLISIONS list
						if grainInfo.get(grty)=="pos":
							if d < potMat[3,4]:
								print([grain,empty,potMat[3,4]-d]) # this should be in the COLLISIONS list
						if grainInfo.get(grty)=="neg":
							if d < potMat[3,5]:
								print([grain,empty,potMat[3,5]-d]) # this should be in the COLLISIONS list
	if grainInfo.get("grty")=="pos":
		loc = grain.loc
		seq = grain.seq # sequential number for the grain in the creation
	for empty, grainInfo in selectedModel.items():
		if grainInfo.get("num")>seq+5: #to avoid considering the second grain too near (in the sequence) to the first
			if numpy.abs(loc[0],empty.loc[0])<7:
				if numpy.abs(loc[1],empty.loc[1])<7:
					if numpy.abs(loc[2],empty.loc[2])<7:
						d = dist(loc,empty.loc)
						if grainInfo.get(grty)=="caa":
							if d < potMat[4,1]:
								print([grain,empty,potMat[4,1]-d]) # this should be in the COLLISIONS list
						if grainInfo.get(grty)=="lip":
							if d < potMat[4,2]:
								print([grain,empty,potMat[4,2]-d]) # this should be in the COLLISIONS list
						if grainInfo.get(grty)=="hyd":
							if d < potMat[4,3]:
								print([grain,empty,potMat[4,3]-d]) # this should be in the COLLISIONS list
						if grainInfo.get(grty)=="pos":
							if d < potMat[4,4]:
								print([grain,empty,potMat[4,4]-d]) # this should be in the COLLISIONS list
						if grainInfo.get(grty)=="neg":
							if d < potMat[4,5]:
								print([grain,empty,potMat[4,5]-d]) # this should be in the COLLISIONS list
	if grainInfo.get("grty")=="neg":
		loc = grain.loc
		seq = grain.seq # sequential number for the grain in the creation
	for empty, grainInfo in selectedModel.items():
		if grainInfo.get("num")>seq+5: #to avoid considering the second grain too near (in the sequence) to the first
			if numpy.abs(loc[0],empty.loc[0])<7:
				if numpy.abs(loc[1],empty.loc[1])<7:
					if numpy.abs(loc[2],empty.loc[2])<7:
						d = dist(loc,empty.loc)
						if grainInfo.get(grty)=="caa":
							if d < potMat[5,1]:
								print([grain,empty,potMat[5,1]-d]) # this should be in the COLLISIONS list
						if grainInfo.get(grty)=="lip":
							if d < potMat[5,2]:
								print([grain,empty,potMat[5,2]-d]) # this should be in the COLLISIONS list
						if grainInfo.get(grty)=="hyd":
							if d < potMat[5,3]:
								print([grain,empty,potMat[5,3]-d]) # this should be in the COLLISIONS list
						if grainInfo.get(grty)=="pos":
							if d < potMat[5,4]:
								print([grain,empty,potMat[5,4]-d]) # this should be in the COLLISIONS list
						if grainInfo.get(grty)=="neg":
							if d < potMat[5,5]:
								print([grain,empty,potMat[5,5]-d]) # this should be in the COLLISIONS list


# GIVE THE COMMAND: CREATE THE LIST OF ALL PAIRS OF GRAINS COLLIDING
# NOTE: THE CONDITION ON THE SEQUENTIAL NUMBER PREVENTS FROM HAVING TWICE THE SAME PAIR OF GRAINS IN THE LIST.
