#####################################################################
#Functions to write dynamically the files and the list of proteins, chains and aminoacids from the objects imported in the scene
#####################################################################

from bpy import *
from .settings import *
from .parsers import *
from .web import *

filePath1 = homePath+"BBV1.py"
filePathmodel1 = homePath+"BBV1_model.py"
filePath2= homePath+"BBV2.py"
filePathmodel2 = homePath+"BBV2_model.py"
filePath3 = homePath+"BBV3.py"
filePathmodel3 = homePath+"BBV3_model.py"

def rewrite_Visualizer():
	#writes the three file to be reloaded: BBV1, BBV2, BBV3
	print("rewrite")
	   #file 1: proteins
	file = open(filePath1,"w")
	file.write("")
	file.close
	filemodel=open(filePathmodel1,"r")
	file = open(filePath1,"w")
	for line in filemodel:
		file.write(line)
	filemodel.close
	file.close
	# file 2 : Chains
	file = open(filePath2,"w")
	file.write("")
	file.close
	filemodel=open(filePathmodel2,"r")
	file = open(filePath2,"w")
	for line in filemodel:
		file.write(line)
	filemodel.close
	file.close
	# file 3: aminoacids
	file = open(filePath3,"w")
	file.write("")
	file.close
	filemodel=open(filePathmodel3,"r")
	file = open(filePath3,"w")
	for line in filemodel:
		file.write(line)
	filemodel.close
	file.close
	
def write_aa(to_List=[], verbose = False,kindOf="",selected=""):
	rewrite_Visualizer()
	ppList=[]
	chainsList=[]
	listmia=[]
	#writes the protein list from all the objects imported in scene
	iteminfo="all"
	i=1
	if len(to_List)>0:
		ppList.append(iteminfo)
		for item in to_List:
			iteminfo=to_List[i-1][0]
			listmia.append(iteminfo)
			if not iteminfo in ppList:
				ppList.append(iteminfo)
			i=i+1
	if len(ppList)>0:
		file = open(filePath1,"a")
		menustring=chr(10)+chr(10)+"types.Scene.BBViewProteinsList = Enum(attr='BBViewProteinsList', name='View Proteins List', description='Select a Protein',"+chr(10)
		i=1
		for item in ppList:
			if i==1:
				menustring=menustring+chr(9)+"items=(('"+ppList[i-1]+"', '"+ppList[i-1]+" ', '')"
			if i!=1:
				menustring=menustring+","+chr(10)+chr(9)+chr(9)+"('"+ppList[i-1]+"', '"+ppList[i-1]+"', '')"
			i=i+1
		menustring=menustring+"),"+chr(10)+chr(9)+"default='1')"+chr(10)
		file.write(menustring)
		menustring=chr(10)+"class BBPanel_Proteins_List(BBPanel1, types.Panel):" + chr(10) + \
		chr(9)+"bl_label = 'View Proteins list'"+ chr(10)+\
		chr(9)+"def draw(self, context):"+ chr(10)+\
		chr(9)+chr(9)+"scene = context.scene"+ chr(10)+\
		chr(9)+chr(9)+"layout = self.layout"+ chr(10)+\
		chr(9)+chr(9)+"split = layout.split(percentage=0.7)"+ chr(10)+\
		chr(9)+chr(9)+"c=split.column()"+chr(10)+\
		chr(9)+chr(9)+"c.prop(scene, 'BBViewProteinsList', expand=True)"+chr(10)+\
		chr(9)+chr(9)+"right = split.column()"+chr(10)+\
		chr(9)+chr(9)+"c = right.column(align=True)"+chr(10)+\
		chr(9)+chr(9)+"c.operator('BBOperatorUpdate',text='Update List',icon='FILE_REFRESH')"+chr(10)
		file.write(menustring)
		file.close()
	#writes the chains list from all the objects imported in scene
	iteminfo="all"
	written_all=""
	i=1
	if len(to_List)>0:
		if not(kindOf=="protein" and selected !="all"):
			chainsList.append(iteminfo)
		for item in to_List:
			iteminfo=to_List[i-1][1].split(" ")[0] + " " +to_List[i-1][0]
			iteminfotab="   "+iteminfo
			if not iteminfotab in chainsList:
				if iteminfo.split(" ")[1]  + " all" !=written_all:
					iteminfo1=iteminfo.split(" ")[1]+ " all"
					if not iteminfo1 in chainsList:
						chainsList.append(iteminfo1)
						written_all=to_List[i-1][1].split(" ")[1]
				chainsList.append(iteminfotab) 
			i=i+1
	if len(chainsList)>0:
		file = open(filePath2,"a")
		menustring=chr(10)+chr(10)+"types.Scene.BBViewChainsList = Enum(attr='BBViewChainsList', name='View Chains List', description='Select a Chain',"+chr(10)
		i=1
		for item in chainsList:
			if i==1:
				menustring=menustring+chr(9)+"items=(('"+chainsList[i-1]+"', '"+chainsList[i-1]+" ', '')"
			if i!=1:
				menustring=menustring+","+chr(10)+chr(9)+chr(9)+"('"+chainsList[i-1]+"', '"+chainsList[i-1]+"', '')"
			i=i+1
		menustring=menustring+"),"+chr(10)+chr(9)+"default='1')"+chr(10)
		file.write(menustring)
		menustring=chr(10)+"class BBPanel_Chains_List(BBPanel1, types.Panel):" + chr(10) + \
		chr(9)+"bl_label = 'View Chains list'"+ chr(10)+\
		chr(9)+"def draw(self, context):"+ chr(10)+\
		chr(9)+chr(9)+"scene = context.scene"+ chr(10)+\
		chr(9)+chr(9)+"layout = self.layout"+ chr(10)+\
		chr(9)+chr(9)+"split = layout.split(percentage=0.7)"+ chr(10)+\
		chr(9)+chr(9)+"split.prop(scene, 'BBViewChainsList', expand=True)"+ chr(10)
		file.write(menustring)
		file.close()
	#writes the aminoacid list from all the objects imported in scene
	if len(to_List)>0:
		file = open(filePath3,"a")
		menustring=chr(10)+chr(10)+"types.Scene.BBViewList = Enum(attr='BBViewList', name='View Aminoacids List', description='Select an Aminoacid',"+chr(10)
		i=1
		for item in to_List:
			if i==1:
				menustring=menustring+chr(9)+"items=(('"+str(to_List[i-1][1]+" " +to_List[i-1][0])+"', '"+to_List[i-1][1]+" " +to_List[i-1][0]+" ', '')"
			if i!=1:
				menustring=menustring+","+chr(10)+chr(9)+chr(9)+"('"+str(to_List[i-1][1]+" " +to_List[i-1][0])+"', '"+to_List[i-1][1]+" " +to_List[i-1][0]+"', '')"
			i=i+1
		menustring=menustring+"),"+chr(10)+chr(9)+"default='1')"+chr(10)
		file.write(menustring)
		menustring=chr(10)+"class BBPanel_Aminoacids_List(BBPanel1, types.Panel):" + chr(10) + \
		chr(9)+"bl_label = 'View Aminoacids list'"+ chr(10)+\
		chr(9)+"bl_options='DEFAULT_CLOSED'"+ chr(10)+\
		chr(9)+"def draw(self, context):"+ chr(10)+\
		chr(9)+chr(9)+"scene = context.scene"+ chr(10)+\
		chr(9)+chr(9)+"layout = self.layout"+ chr(10)+\
		chr(9)+chr(9)+"split = layout.split(percentage=0.7)"+ chr(10)+\
		chr(9)+chr(9)+"split.prop(scene, 'BBViewList', expand=True)"+ chr(10)
		file.write(menustring)
		file.close()